import 'dart:html';

class UserInterface {

  final FormElement _form = querySelector('#chatForm');
  final UListElement _ul = querySelector('#chatMessages');
  final TextInputElement _inputField = querySelector('#chatInput');

  UserInterface() {
    _inputField.focus();
  }

  void onTextInput(callback) {
    _form.onSubmit.listen((event){
      final txt = this.textFieldValue();
      callback(txt);
      event.preventDefault();
    });
  }

  String textFieldValue() {
    return _inputField.value;
  }

  void appendListItemWithText(String newText) {
    final li = new LIElement();
    li.text = newText;
    _ul.append(li);
  }

  void resetInputField() {
    _inputField.value = "";
    _inputField.focus();
  }

}
